#include "lcd_drv.h"

//--------------------------------THIS CODE MUST BE CHANGED FOR OUR LCD--------------------------

//LCD INFO
//Default Communication Parameters
//Baudrate:  ............ 115200 bps
//No of Stop Bits: .... 1
//Parity: .................. Off
//Handshake: .......... None
 



void LCDCmd(u_int cmd) {
	while(canTrans()==0){
		//do nothing
	}
	
	at91_usart_write (&USART1_DESC, cmd); 
}

int canTrans(){
	if((at91_usart_get_status(&USART1_DESC) & US_TXRDY) == 0){
		return 0;
	}
	else{
		return 1;
	}
}
void LCDOpen(){
	u_int baudCD;
	baudCD = 32000000/(16* 115200);		//interger div
	at91_usart_open(&USART1_DESC, US_ASYNC_MODE, baudCD, 0);
}

void LCDClose(){
	at91_usart_close(&USART1_DESC);
}

void LCDInit(void) { 
	LCDOpen();
	LightOn();
	SetColor(LCD_WHITE);
	Cls();
}



void drawScreen(){
	//grid origin is at 0,0
	//each square is 8px by 8px
	//width of grid is 80
	//height is 160
	int indx;

	//Clear screen to black.
	SetColor(LCD_WHITE);
	Cls();


	//create Black Game Box
	SetColor(LCD_BLACK); 
	SetXY(0,0);
	BoxFill(LCD_GRID_W,LCD_GRID_H);

	//Add Grid Lines
	SetColor(LCD_WHITE);

	//SetXY(0,0);
	//HLine(LCD_GRID_W);
	for(indx=7; indx<LCD_GRID_H; indx = indx+8){
		SetXY(0,indx);
		HLine(LCD_GRID_W);
	}

	//Draw Vertical Lines
	//SetXY(0,0);
	//VLine(LCD_GRID_H);
	for(indx=7; indx<LCD_GRID_W; indx = indx+8){
		SetXY(indx, 0);
		VLine(LCD_GRID_H);
	}

	//Draw Score Table
	//DrawInfo();

}

void DrawGrid(){
	//grid origin is at 0,0
	//each square is 8px by 8px
	//width of grid is 80
	//height is 160
	int indx;

	//create Black Game Box
	SetColor(LCD_BLACK); 
	SetXY(0,0);
	BoxFill(LCD_GRID_W,LCD_GRID_H);

	//Add Grid Lines
	SetColor(LCD_WHITE);

	//SetXY(0,0);
	//HLine(LCD_GRID_W);
	for(indx=7; indx<LCD_GRID_H; indx = indx+8){
		SetXY(0,indx);
		HLine(LCD_GRID_W);
	}

	//Draw Vertical Lines
	//SetXY(0,0);
	//VLine(LCD_GRID_H);
	for(indx=7; indx<LCD_GRID_W; indx = indx+8){
		SetXY(indx, 0);
		VLine(LCD_GRID_H);
	}

}






void DrawBlock(int x, int y,int color){
	SetColor(color);   
	


	SetXY(x*LCD_BLOCK_PX, y*LCD_BLOCK_PX);
	BoxFill(x*LCD_BLOCK_PX + LCD_BLOCK_SIZ, y*LCD_BLOCK_PX + LCD_BLOCK_SIZ);


}

void clearNext(int gametype){

	//clear next box;
	SetColor(LCD_WHITE);
	SetXY(85, 15);
	BoxFill(125, 55);
	if (gametype == TWIST_TETRAD){
	SetColor(LCD_WHITE);
	SetXY(135, 15);
	BoxFill(175, 55);
	}
	
}

void clearScore(){
	SetColor(LCD_BLUE);

	SetXY(85, 70);
	BoxFill(125, 90);
}
void clearLevel(){
	SetColor(LCD_BLUE);
	SetXY(85, 100);
	BoxFill(125, 120);
}
void clearLines(){
	SetColor(LCD_BLUE);
	SetXY(85, 130);
	BoxFill(125, 150);
}



//CHANGE TO DRAW INFO. 
void DrawInfo(int score, int level, int lines, int gametype){

	char strScore[LCD_MAX_STR];
	char strLevel[LCD_MAX_STR];
	char strLines[LCD_MAX_STR];
	
	
	
	//init the level lines and score strings
	
	sprintf(strScore, "%i\0", score);
	sprintf(strLevel, "%i\0", level);
	sprintf(strLines, "%i\0", lines);
	
	//clear area behind panel.
	SetColor(LCD_BLUE);
	SetXY(LCD_INFO_ORG_X, LCD_INFO_ORG_Y);
	BoxFill(LCD_INFO_END_X, LCD_INFO_END_Y);

	//next box.
	SetColor(LCD_WHITE);
	SetXY(85, 15);
	BoxFill(125, 55);
	if(gametype == TWIST_TETRAD){
	SetColor(LCD_WHITE);
	SetXY(135, 15);
	BoxFill(175, 55);
	}
	
	//text
	DrawString(1, LCD_WHITE, 85, 2, "Next Up:\0", sizeof("Next Up:\0"));
	

	SelectFont(1);
	SetColor(LCD_WHITE);
	SetXY(85,60);
	PrintString("Current Score:\0",sizeof("Current Score:\0"));
	SetXY(85,70);
	PrintString(strScore,sizeof(strScore));

	SetXY(85,90);
	PrintString("Level:\0",sizeof("Level:\0"));
	SetXY(85,100);
	PrintString(strLevel,sizeof(strLevel));


	SetXY(85,120);
	PrintString("Lines Cleared:\0",sizeof("Lines Cleared:\0"));
	SetXY(85,130);
	PrintString(strLines,sizeof(strLines));
}



//CHANGE TO DRAW MENU
void DrawMenu(struct strMenu * menu){
	u_int indx;

	//parameters to setup list
	u_int lstfont;
	u_int lstclr;
	u_int lstx;
	u_int lsty;
	u_int lsty_off; //offset;

	//parameters for displaying selected Item. 
	u_int box_org_x, box_org_y, box_end_x, box_end_y;

	//clear AREA BEHIND Panel
	SetColor(LCD_BLUE);
	SetXY(LCD_INFO_ORG_X, LCD_INFO_ORG_Y);
	BoxFill(LCD_INFO_END_X, LCD_INFO_END_Y);

	//selectFont(1);
	//Write Menu
	SelectFont(3);
	SetColor(LCD_RED);
	SetXY(85,2);
	PrintString("M",sizeof("M"));
	SetColor(LCD_ORANGE);
	SetXY(110,2);
	PrintString("E",sizeof("E"));
	SetColor(LCD_YELLOW);
	SetXY(130,2);
	PrintString("N",sizeof("N"));
	SetColor(LCD_GREEN);
	SetXY(150,2);
	PrintString("U",sizeof("U"));

	//write list. 
	lstfont = 1;
	lstclr = LCD_WHITE;
	lstx = 90;
	lsty = 35;
	lsty_off = 20; //offset;


	for(indx=0; indx< menu->itemLen; indx++){
		
		switch(menu->item[indx]){
		case PlayPause:
			
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_PLAYPAUSE, sizeof(LCD_STR_PLAYPAUSE));
			break;
		case Restart:
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_RESTART, sizeof(LCD_STR_RESTART));
			break;
		case Quit:
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_QUIT, sizeof(LCD_STR_QUIT));
			break;
		case Classic:
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_CLASS, sizeof(LCD_STR_CLASS));
			break;
		case Twisted:
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_TWIST, sizeof(LCD_STR_TWIST));
			break;
		case Strategic:	
			DrawString(lstfont,lstclr,lstx,lsty + indx*lsty_off,LCD_STR_STRAT, sizeof(LCD_STR_STRAT));
			break;
		}
	}

	//Draw Box around Selected.
	SetColor(LCD_RED); 
	indx= menu->sel;

	box_org_x = lstx-5;
	box_org_y = (lsty + indx*lsty_off)-1;
	box_end_x = 145;
	box_end_y = (lsty + indx*lsty_off)+13;
	SetXY(box_org_x,box_org_y);
	Box(box_end_x,box_end_y);

}

void DrawString(u_int font, u_int color, u_int x, u_int y, char * msg, u_int msgLen){


	SelectFont(font);
	SetColor(color);
	SetXY(x,y);
	PrintString(msg,msgLen);


}


void TETRISSide(){
	//00001
	//11111
	//00001

	//11111
	//10101
	//10101

	//11111
	//01101
	//10111

	//10001
	//11111
	//10001

	//10111
	//10101
	//11101


}







//LCD Defined Functions.
void Cls(){
	LCDCmd(LCD_CLS);
}
void LightOn(){
	LCDCmd(LCD_LIGHT_ON);
}
void LightOff(){
	LCDCmd(LCD_LIGHT_OFF);
}
void SetColor(u_int color){
	LCDCmd(LCD_SET_COLOR);
	LCDCmd(color);
}
void SetXY(u_int X, u_int Y){
	LCDCmd(LCD_SET_XY);
	LCDCmd(X);
	LCDCmd(Y);
}
void Plot(){
	LCDCmd(LCD_PLOT);
}
void PlotXY(u_int X, u_int Y){
	LCDCmd(LCD_PLOT_XY);
	LCDCmd(X);
	LCDCmd(Y);
}
void HLine(u_int X){
	LCDCmd(LCD_H_LINE);
	LCDCmd(X);
}
void VLine(u_int Y){
	LCDCmd(LCD_V_LINE);
	LCDCmd(Y);
}
void LineToXY(u_int X, u_int Y){
	LCDCmd(LCD_LINE_TO_XY);
	LCDCmd(X);
	LCDCmd(Y);
}
void Arc(u_int radius, u_int begin_angle, u_int end_angle){
	LCDCmd(LCD_ARC);
	LCDCmd(radius);
	LCDCmd(begin_angle);
	LCDCmd(end_angle);
}
void CircleR(u_int radius){
	LCDCmd(LCD_CIRCLE_R);
	LCDCmd(radius);
}
void CircleRFill(u_int radius){
	LCDCmd(LCD_CIRCLE_R_FILL);
	LCDCmd(radius);
}
void Box(u_int X_2, u_int Y_2){
	LCDCmd(LCD_BOX);
	LCDCmd(X_2);
	LCDCmd(Y_2);
}
void BoxFill(u_int X_2, u_int Y_2){
	LCDCmd(LCD_BOX_FILL);
	LCDCmd(X_2);
	LCDCmd(Y_2);
}
void PutBitmap(u_int width, u_int height, u_int array[],int arr_len){
	int indx;
	LCDCmd(LCD_PUT_BITMAP);
	for(indx=0; indx<arr_len; indx++){
		LCDCmd(array[indx]);
	}
}
void PutIcon(u_int iconID){
	LCDCmd(LCD_PUT_ICON);
	LCDCmd(iconID);
}
void PutSFIcon(u_int IconID){
	LCDCmd(LCD_PUT_SF_ICON);
	LCDCmd(IconID);
}
void Picture(u_int * array, int arr_len){
	int indx;
	LCDCmd(LCD_PICTURE);
	for(indx=0; indx<arr_len; indx++){
		LCDCmd(array[indx]);
	}
}
void SelectFont(u_int fontNumber){
	LCDCmd(LCD_SELECT_FONT);
	LCDCmd(fontNumber);
}
void SetBGColor(u_int color){
	LCDCmd(LCD_SET_BG_COLOR);
	LCDCmd(color);
}
void TextNorth(){
	LCDCmd(LCD_TEXT_NORTH);
}
void TextEast(){
	LCDCmd(LCD_TEXT_EAST);
}
void TextSouth(){
	LCDCmd(LCD_TEXT_SOUTH);
}
void TextWest(){
	LCDCmd(LCD_TEXT_WEST);
}
void PrintChar(u_int ASCII){
	LCDCmd(LCD_PRINT_CHAR);
	LCDCmd(ASCII);
}
void PrintCharBG(u_int ASCII){
	LCDCmd(LCD_PRINT_CHAR_BG);
	LCDCmd(ASCII);
}
void PrintString(char str[], int str_len){
	int indx;
	LCDCmd(LCD_PRINT_STRING);
	for(indx=0; indx<str_len; indx++){
		LCDCmd(str[indx]);
	}
}
void PrintStringBG(char str[], int str_len){
	int indx;
	LCDCmd(LCD_PRINT_STRING_BG);
	for(indx=0;indx<str_len; indx++){
		LCDCmd(str[indx]);
	}
}






