/* main.c for Lab #1
	Nancy Minderman 
	April 20, 2007
	This file should be useable by all three programs in the lab1 project
	*/


#ifdef SEMIHOSTING
#include <stdio.h>
#include <time.h>
#include <math.h>
#endif

#include "parts/m55800/lib_m55800.h"
#include "drivers/capture/capture.h"
#include "drivers/wait/wait.h"
#include "parts/m55800/eb55.h"
//#include "lcd_drv.h"
#include "tetris.h"
#include "snd_drv.h"



extern void irq_asm_irq_handler(void);
extern void irq_asm_irq_lcdhandler(void);
extern void wake_up_handler (void) ;
 
//function prototypes
void IRQ_Enable();
void IRQ_Disable();

/* Global Variable */
WaitDesc wait_desc = { &TC0_DESC, 0, 0, WAIT_DELAY, wake_up_handler } ;
//u_int   LedSpeed ;
struct strGameData game;
ExtIrqDesc myIRQ28;


u_int lcd[2];
int counter;


//* End


//*----------------------------------------------------------------------------
//* Function Name       : main
//* Object              : Main function of the led swing
//* Input Parameters    : none
//* Output Parameters   : True
//*----------------------------------------------------------------------------
int main( void )
//* Begin
{
	int i;
	int prevtime;
	int levelloop;
	u_int * test;
	u_int * enableirq;
	u_int baudCD;
	u_int data;


	//INIT IRQ
	myIRQ28.pio_ctrl = &PIOA_DESC;
	myIRQ28.source_id = 28;
	myIRQ28.pin_irq = 10;
	
	at91_extirq_open(&myIRQ28, 5, AIC_SRCTYPE_EXT_POSITIVE_EDGE, (u_int)irq_asm_irq_handler);

	//code to remove. 
	

	
	
	at91_irq_open ( 3, 5, AIC_SRCTYPE_INT_EDGE_TRIGGERED, (u_int)irq_asm_irq_lcdhandler );
	//at91_extirq_open(&myIRQLCD, 5, AIC_SRCTYPE_EXT_POSITIVE_EDGE, (u_int)irq_asm_irq_handler);
	
	
	/*
	baudCD = 32000000/(16* 115200);		//interger div
	at91_usart_open(&USART1_DESC, US_ASYNC_MODE, baudCD, 0);
	while(1){
	    printf("%X\n", at91_usart_get_status(&USART1_DESC) & US_RXRDY);
		if (at91_usart_get_status(&USART1_DESC) & US_RXRDY == 1){
			 at91_usart_read  ( &USART1_DESC, &data ) ;
			printf("data read: %X\n", data);
		} 
	
	}
	*/
	
	
	
	LCDOpen();
	LCDInit();
	srand(time(0));
	rand();
	
	
	//replace with game reset function. 
	memset(&game, 0, sizeof(struct strGameData));
	game.grid_h = GAME_HEIGHT;
	game.grid_w = GAME_WIDTH;
	game.info.level = 1;//NEWCODE
	game.gametype = CLASS_TETRAD;
	genRandTetrad(&game.currBlock, game.gametype);
	genRandTetrad(&game.nextBlock, game.gametype);
	initMenus(&game);
	

	
	
	//LCDInit();
	DrawGrid();
	DrawInfo(game.info.score, game.info.level, game.info.lines, game.gametype);
	printTetris();
	
	printTetrad(&game.currBlock);
	printNext(&game.nextBlock, game.gametype, &game.next2Block);
	//prevtime=time(0);
	
	game.mode =GAMEPLAY;
	
	counter=0;
	enableirq = 0xFFFC4008;
	*enableirq = 0x01;
	//test  = 0xFFFC4010;
	//printf("USART1 CONFIG: %X\n",*test);
	
	
	while(1){

		//if(time(0)-prevtime>2){
		//prevtime=time(0);
		//levelloop= 1000000 - ((game.info.level-1)*25000);
		levelloop= 1000000 - (((game.info.level-1)+genRandTwisted(game.gametype))*75000);
		
		for(i=1; i<levelloop; i++){
		//POLLING CODE REMOVE
		//if (at91_usart_get_status(&USART1_DESC) & US_RXRDY == 1){
		//	 at91_usart_read  ( &USART1_DESC, &data ) ;
		//	printf("##data read: %X\n", data);
		//} 
		//printf("## lcd values: start: %X, end: %X\n", lcd[0], lcd[1]);
		} 
		
		
		
		if(game.mode == GAMEPLAY){
			IRQ_Disable();
			//printf("LCD: start col:%X, endcol:%X\n", lcd[0], lcd[1]);
			moveDown(&game.currBlock,&game);
			
			//printf("score: %i, level: %i, lines: %i\n", game.info.score, game.info.level, game.info.lines);
			IRQ_Enable();
		}
		at91_usart_read  ( &USART1_DESC, &data ) ;
	}

	
}
void IRQ_Enable(){
	myIRQ28.pio_ctrl = &PIOA_DESC;
	myIRQ28.source_id = 28;
	myIRQ28.pin_irq = 10;
	
	at91_extirq_open(&myIRQ28, 5, AIC_SRCTYPE_EXT_POSITIVE_EDGE, (u_int)irq_asm_irq_handler); 
	at91_irq_open ( 3, 5, AIC_SRCTYPE_INT_EDGE_TRIGGERED, (u_int)irq_asm_irq_lcdhandler );
	
	
}

void IRQ_Disable(){
	at91_extirq_close(&myIRQ28);
	at91_irq_close ( 3 );

}



//*----------------------------------------------------------------------------
//* Function Name       : c_handler
//* Object              : Interrupt Handler for Keypress
//* Input Parameters    : none
//* Output Parameters   : True
//*----------------------------------------------------------------------------
void c_handler( void )
//* Begin
{
	
	u_short* y;
	u_int statusB = at91_pio_read (&PIOB_DESC);
	
	
	y = (u_short*)&statusB ;
	
	counter++; //ugly hack to get interrupts working properly.
	IRQ_Disable();
	
	if(counter%2 ==0){ 
		
		switch (y[1])
		{
		case 0x0FFB:
			//  printf("pressed:1");
			
			break;
		case 0x0FDB:
			// printf("pressed:2");
			break;
		case 0x0FBB:
			// printf("pressed:3");
			break;
		case 0x0F9B:
			playPause(&game);
			//printf("pressed:4");
			break;
		case 0x0F1B:
			// printf("pressed:5");
			break;
		case 0x0E9B:
			//printf("pressed:6");
			break;
		case 0x0E1B:
			//printf("pressed:7");
			break;
		case 0x0F5B: //0x0EFB:
			//printf("pressed:Up");
			if(game.mode == GAMEPLAY){
				game.info.counter++;
			}
			moveUp(&game);
			break;
		case 0x0E5B:  //0x0EBB:
			//printf("pressed:Down");
			if(game.mode == GAMEPLAY){
				game.info.counter++;
			}
			moveDown(&game.currBlock, &game);
			break;
		case 0x0EFB: //0x0E5B:
			//printf("pressed:Left");
			if(game.mode == GAMEPLAY){
				game.info.counter++;
			}
			moveLeft(&game.currBlock, &game);
			break;
		case 0x0EBB: //0x0F5B:
			//printf("pressed:Right");
			if(game.mode == GAMEPLAY){
				game.info.counter++;
			}
			moveRight(&game.currBlock, &game);
			break;
		case 0x0E7B:
			//printf("pressed:Upper-Left");
			break;
		case 0x0F7B:
			//printf("pressed:Upper-Right");
			break;
		case 0x0E3B:
			//printf("pressed:Bottom-Left");
			break;
		case 0x0F3B:
			//printf("pressed:Bottom-Right");
			break;
		case 0x0EDB:
			//printf("pressed:Center");
			
			rotTetrad(&game.currBlock,&game);
				
			
			break;		
		default:
			//printf("pressed:Invalid");
			break;
		}
		if(game.gametype == STRAT_TETRAD){
			hideTetrisPanel(&game);
		}
		
	}
	
	IRQ_Enable();
}
 
 
// 

void lcd_c_handler(void){
	
	int start_col=0;
	int end_col=0;
	u_int lcdcount =0;
	u_int data=0x00;
	u_int col_mask = 0x0F;
	
	

	//if (lcdcount%2 == 0){
	at91_usart_read  ( &USART1_DESC, &data ) ;
    IRQ_Disable();
	
	
	
	
	
	while(data != 0xFF){
		if (lcdcount !=2){
			lcd[lcdcount] = data;
			lcdcount++;
		}
		else{
			lcd[1] = data;
		}
		at91_usart_read  ( &USART1_DESC, &data ) ;
	}
	//FF recieved, calc direction or drop
	if(lcdcount != 2){ //drop
	
	if(game.mode == GAMEPLAY){
	    game.info.counter++;
	}
	
	moveUp(&game);
	
	}
	else{
		start_col  = lcd[0]&col_mask;
		end_col  = lcd[1]&col_mask;
		if(end_col >start_col ){
			//move right
			if(game.mode == GAMEPLAY){
			game.info.counter++;
			}
			moveRight(&game.currBlock, &game);
		}
		else{
			//move left
			if(game.mode == GAMEPLAY){
				game.info.counter++;
			}
			moveLeft(&game.currBlock, &game);
		}


	}
	
	
	
	
	
	
	/*
	if(game.mode == GAMEPLAY){
	    game.info.counter++;
	}
	moveUp(&game);
	
	*/
	IRQ_Enable();
	//at91_usart_read  ( &USART1_DESC, &data ) ;
	//}
}
	

