

#include "lcd_drv.h"
//#include "menu.h"


#define GAME_WIDTH 10
#define GAME_HEIGHT 20
#define THREE_BLOCK 3
#define FOUR_BLOCK 4

#define NOTGHOST 0
#define GHOST 1



//Tetris shapes, colors defined from http://en.wikipedia.org/wiki/Tetris

//copy to lcd_drv.h
#define CLASS_TETRAD 0
#define TWIST_TETRAD 1
#define STRAT_TETRAD 2

#define IBlock 0
#define JBlock 1
#define LBlock 2
#define OBlock 3
#define SBlock 4
#define TBlock 5
#define ZBlock 6
#define NBlock1 7
#define NBlock2 8
#define NBlock3 9
#define NBlock4 10
#define NBlock5 11
#define NBlock6 12
#define NBlock7 13
#define NBlock8 14
#define NBlock9 15
#define NBlock10 16
#define NBlock11 17
#define NBlock12 18
#define NBlock13 19
#define NBlock14 20
#define NBlock15 21
#define NBlock16 22
#define NBlock17 23
#define BOMB 24

#define ERR -1

//GAME MODES
#define GAMEINMENU 0 	//pause menu
#define GAMEOUTMENU 1	//new game menu
#define GAMEPLAY 2		//playing game. 



//MENU INFO
#define MNU_MAX_LEN 10 	//max length of word in menu. 

//External Function Prototypes
extern void DrawBlock(int x, int y,int color);
extern void DrawScores();
extern void LCDOpen();
extern void LCDCmd(u_int cmd);
extern void drawScreen();

struct strGameScore{
	int level;
	int score;
	int lines;
	int counter;

};

struct strBlock 
{
	int ghosty;//ghost y coord.
	int array[FOUR_BLOCK][FOUR_BLOCK];
	int size;
	int type;
	int xpos;
	int ypos;
};


struct strGameData {
	struct strBlock currBlock;
	struct strBlock nextBlock;
	struct strBlock next2Block;
    struct strGameScore info;
	int grid[GAME_WIDTH][GAME_HEIGHT];
	int grid_w;
	int grid_h ;
	int mode;					//MUST BE A GAME MODE DEFINED ABOVE.
	struct strMenu menuVer[2]; 	//menu Version, 0 is the ingame menu, 1 is the new game menu. 
	int gametype;				//gametype, either Classic or Twisted.  CLASS_TETRAD, TWIST_TETRAD
};
//Interrupts
#define IRQ_StartStop 1
#define IRQ_Left 2
#define IRQ_Right 3
#define IRQ_Down 4
#define IRQ_Rotate 5
#define IRQ_Timer 6



//Function Prototypes
void printTetrad(struct strBlock *Tetrad);
void printBoard(struct strGameData * game);
void clearTetrad(struct strBlock *Tetrad);
int rotTetrad(struct strBlock *Tetrad, struct strGameData * game);
int blockCollide(struct strBlock *Tetrad, struct strGameData * curr_game, int isGhost);
void createTetrad(struct strBlock *Tetrad, int BlockType);

//Interrupts
int moveDown(struct strBlock *Tetrad, struct strGameData * curr_game);
void moveLeft(struct strBlock *Tetrad, struct strGameData * curr_game);
void moveRight(struct strBlock *Tetrad, struct strGameData * curr_game);
//change timer and rand function
int timer(int * prev);
void genRandTetrad(struct strBlock *Tetrad, int gameType);


void setTetrad(struct strBlock *Tetrad, struct strGameData * game);
void clearRow(u_int fullrows[],int * count, struct strGameData *game);
int checkRow(struct strGameData *game);

void hideTetrisPanel(struct strGameData *game);
//Menu Code
void initMenus(struct strGameData * curr_game);
void RestartGame(struct strGameData * curr_game);
void playPause(struct strGameData * curr_game);
void printGameOver();
void increaseLines(int count, struct strGameData * game);
void setScore(int count, struct strGameData * game);
void printTetris();
int genRandTwisted(int mode);
void printNext(struct strBlock *Tetrad,int gametype, struct strBlock *Tetrad2);
